/*!
 * rollup-plugin-templatejs 3.1.2-alpha.0 (https://github.com/yanhaijing/template.js)
 * API https://github.com/yanhaijing/template.js
 * Copyright 2017-2023 yanhaijing. All Rights Reserved
 * Licensed under MIT (https://github.com/yanhaijing/template.js/blob/master/LICENSE)
 */

'use strict';

var path = require('path');
var rollupPluginutils = require('rollup-pluginutils');
var extend = require('@jsmini/extend');
var precompiler = require('@templatejs/precompiler');

function ownKeys(e, r) {
  var t = Object.keys(e);
  if (Object.getOwnPropertySymbols) {
    var o = Object.getOwnPropertySymbols(e);
    r && (o = o.filter(function (r) {
      return Object.getOwnPropertyDescriptor(e, r).enumerable;
    })), t.push.apply(t, o);
  }
  return t;
}
function _objectSpread2(e) {
  for (var r = 1; r < arguments.length; r++) {
    var t = null != arguments[r] ? arguments[r] : {};
    r % 2 ? ownKeys(Object(t), !0).forEach(function (r) {
      _defineProperty(e, r, t[r]);
    }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) {
      Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r));
    });
  }
  return e;
}
function _defineProperty(obj, key, value) {
  key = _toPropertyKey(key);
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }
  return obj;
}
function _toPrimitive(input, hint) {
  if (typeof input !== "object" || input === null) return input;
  var prim = input[Symbol.toPrimitive];
  if (prim !== undefined) {
    var res = prim.call(input, hint || "default");
    if (typeof res !== "object") return res;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return (hint === "string" ? String : Number)(input);
}
function _toPropertyKey(arg) {
  var key = _toPrimitive(arg, "string");
  return typeof key === "symbol" ? key : String(key);
}

function index () {
  var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var _options = options = extend.extendDeep({
      include: ['**/*.tmpl'],
      exclude: 'node_modules/**'
    }, options),
    include = _options.include,
    exclude = _options.exclude;
  var filter = rollupPluginutils.createFilter(include, exclude);
  // var sourceMap = options.sourceMap !== false;
  return {
    transform: function transform(tpl, id) {
      if (!filter(id)) return;
      options.tplName = path.basename(id);
      var source = precompiler.precompile(tpl, _objectSpread2(_objectSpread2({}, options), {}, {
        expression: 'template'
      }));
      var compiled = "import template from '@templatejs/runtime'; export default ".concat(source);
      return {
        code: compiled,
        map: {
          mappings: ''
        }
      };
    }
  };
}

module.exports = index;
//# sourceMappingURL=index.js.map
